-- This Utility will Automatcily create an Sky and Cloud for you max scenes
-- Created by Tetsuya Takee
-- Copyright(C) 1998 Tetsuya Takee

utility cld "Cloud Maker V.1.3"
(
	group "Create"
	(
	button create_cld "Create" width:60 across:2
	button delete_sky "Delete" width:60
	)
	
	group "Sky"
	(
	spinner siz_sky0 "Sky Scale:" range:[0.1,10,1] scale:0.1 enabled:true
	spinner hem_sky0 "Hemisphere:" range:[0.93,0.99,0.98] scale:0.001 enabled:true
	colorpicker sky1_col "" color:[0,10,220] enabled:true offset:[-20,0] across:3
	colorpicker sky2_col "" color:[50,120,255] enabled:true offset:[-20,0]
	colorpicker sky3_col "" color:[220,250,255] enabled:true offset:[-20,0]
	label sky_col "Top----Mid----Botm" offset:[0,0]
	)
	
	group "Cloud Hight"
	(
	spinner siz_cld1 "Size:" range:[0.1,20,1] scale:0.1 enabled:true fieldwidth:38 offset:[5,0] across:2
	colorpicker cld1_col "" color:[255,255,255] enabled:true offset:[-15,0]
	Slider cld1_pha "Cloud Phase:" range:[-10,10,0] enabled:true
	Slider cld1_val "Cloud Value:" range:[-0.3,0.2,0] enabled:true
	)
	
	group "Cloud Mid"
	(
	spinner siz_cld2 "Size:" range:[0.1,20,1] scale:0.1 enabled:true fieldwidth:38 offset:[5,0] across:2
	colorpicker cld2_col "" color:[255,255,255] enabled:true offset:[-15,0]
	Slider cld2_pha "Cloud Phase:" range:[-10,10,0]enabled:true
	Slider cld2_val "Cloud Value:" range:[-0.4,0.3,0]enabled:true
	)
	
	group "Cloud Low"
	(
	spinner siz_cld3 "Size:" range:[0.1,20,1] scale:0.1 enabled:true fieldwidth:38 offset:[5,0] across:2
	colorpicker cld3_col "" color:[255,255,255] enabled:true offset:[-15,0]
	Slider cld3_pha "Cloud Phase:" range:[-10,10,0] enabled:true
	Slider cld3_val "Cloud Value:" range:[-0.3,0.3,0] enabled:true
	)

	group "About"
	(
	label a1 "Beta .1.3 Cloud Maker" 
	label b2 "By Tetsuya Takee" offset:[0,-6]
	button ab "About"
	)
	on ab pressed do
		
		(
		messagebox "Created by Tetsuya Takee 1/28/98, Thanks to Frank DeLise(Enviorment System)"
		messagebox "Checkout http://home.att.ne.jp/gold/takee/ or Email me takee@tka.att.ne.jp"
		)
	
	on create_cld pressed do
		(
		
	--Create BaseSphere
		
		spsk = sphere radius:1150000 pos:[0,0,-10] segs:8 hemisphere:(hem_sky0.value) chop:1 recenter:true mapcoords:true
		addmodifier spsk (normalmodifier flip:true)
		spsk.name = "SkyBase"
		
		spcl0 = sphere radius:1120000 pos:[0,0,-10] segs:8 hemisphere:(hem_sky0.value) chop:1 recenter:true mapcoords:true
		addmodifier spcl0 (normalmodifier flip:true)
		spcl0.name = "CloudHight"
		
		spcl1 = sphere radius:1080000 pos:[0,0,-10] segs:8 hemisphere:(hem_sky0.value) chop:1 recenter:true mapcoords:true
		addmodifier spcl1 (normalmodifier flip:true)
		spcl1.name = "CloudMid"
		
		spcl2 = sphere radius:1040000 pos:[0,0,-10] segs:8 hemisphere:(hem_sky0.value) chop:1 recenter:true mapcoords:true
		addmodifier spcl2 (normalmodifier flip:true)
		spcl2.name = "CloudLowBri"
		
		spcl22 = sphere radius:1300000 pos:[0,0,-10] segs:8 hemisphere:(hem_sky0.value+0.003) chop:1 recenter:true mapcoords:true
		addmodifier spcl22 (normalmodifier flip:true)
		spcl22.name = "CloudLowDark"
		
		
	--Create SkyBase
		
		function Rdraw0 =
		(
		skgr = gradient color1:(sky1_col.color) color2:(sky2_col.color) color3:(sky3_col.color) color2Pos:0.94
		mat0 = standardmaterial diffusemap:skgr shininess:0 shinestrength:0 selfillum:100 opacity:100
		spsk.mat = mat0
		spsk.mat.name = "SkyBaseM"
		)
		Rdraw0()
		
	--Create CloudHight
		
		function Rdraw1 =
		(
		a_nois01 = noise phase:(cld1_pha.value) Noise_Size:(siz_cld1.value*200) noiseType:2 Color_1:(cld1_col.color) Color_2:(cld1_col.color-[55,55,55]) Levels:5.0 Low_Threshold:0.1 High_Threshold:0.9
		a_nois02 = noise phase:(cld1_pha.value+1) Noise_Size:(siz_cld1.value*500) noiseType:2 Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:5.0 Low_Threshold:0.0 High_Threshold:0.9
		a_nois03 = noise phase:(cld1_pha.value) Noise_Size:(siz_cld1.value*150) noiseType:2 Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:7.0 Low_Threshold:0.01 High_Threshold:0.8
		a_nois04 = noise phase:(cld1_pha.value+0.5) Noise_Size:(siz_cld1.value*1000) noiseType:1 map2:a_nois03 map1Enabled:off map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:3.0 Low_Threshold:(cld1_val.value+0.5) High_Threshold:(cld1_val.value+0.8)
		
		mat1 = standardmaterial filter:(Color 133 136 154) diffusemap:a_nois01 selfillummap:a_nois02 opacitymap:a_nois04 shininess:0 shinestrength:0 selfillum:100 opacity:0 diffusemapenable:on selfillummapenable:off opacitymapenable:on
		spcl0.mat = mat1
		spcl0.mat.name = "CloudHightM"
		)
		Rdraw1()
		
	--Create CloudMid
		
		function Rdraw2 =
		(
		m_nois01 = noise phase:(cld2_pha.value+0.2) Noise_Size:(siz_cld2.value*250) noiseType:2 Color_1:(cld2_col.color) Color_2:(cld2_col.color-[55,55,55]) Levels:5.0 Low_Threshold:0.1 High_Threshold:0.9
		m_nois02 = noise phase:(cld2_pha.value+0.2) Noise_Size:(siz_cld2.value*1000) noiseType:2 Color_1:(Color 170 170 170) Color_2:(Color 255 255 255) Levels:5.0 Low_Threshold:0.1 High_Threshold:0.9
		m_nois03 = noise phase:(cld2_pha.value) Noise_Size:(siz_cld2.value*400) noiseType:1 Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:4.0 Low_Threshold:0.1 High_Threshold:0.8
		m_nois04 = noise phase:(cld2_pha.value) Noise_Size:(siz_cld2.value*2000) noiseType:1 map2:m_nois03 map1Enabled:off map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:5.0 Low_Threshold:(cld2_val.value+0.51) High_Threshold:(cld2_val.value+0.66)
		
		mat2 = standardmaterial filter:(Color 180 180 180) diffusemap:m_nois01 selfillummap:m_nois02 opacitymap:m_nois04 shininess:0 shinestrength:0 selfillum:100 opacity:0 diffusemapenable:on selfillummapenable:on opacitymapenable:on
		spcl1.mat = mat2
		spcl1.mat.name = "CloudMidM"
		)
		Rdraw2()
		
	--Create CloudLowBri
		
		function Rdraw3 =
		(
		b_nois01 = noise phase:(cld3_pha.value+0.2) Noise_Size:(siz_cld3.value*500) noiseType:2 Color_1:(cld3_col.color) Color_2:(cld3_col.color-[30,30,30]) Levels:5.0 Low_Threshold:0.1 High_Threshold:0.9
		b_nois02 = noise phase:(cld3_pha.value+0.2) Noise_Size:(siz_cld3.value*1000) noiseType:2 Color_1:(Color 170 170 170) Color_2:(Color 255 255 255) Levels:5.0 Low_Threshold:0.1 High_Threshold:0.9
		b_nois03 = noise phase:(cld3_pha.value+1) Noise_Size:(siz_cld3.value*300) noiseType:1 Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:5.0 Low_Threshold:0.0 High_Threshold:0.7
		b_nois04 = noise phase:(cld3_pha.value) Noise_Size:(siz_cld3.value*3500) noiseType:1 map2:b_nois03 map1Enabled:off map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:3.0 Low_Threshold:(cld3_val.value+0.52) High_Threshold:(cld3_val.value+0.6)
		
		mat3 = standardmaterial filter:(Color 170 170 170) diffusemap:b_nois01 selfillummap:b_nois02 opacitymap:b_nois04 shininess:0 shinestrength:0 selfillum:100 opacity:0 diffusemapenable:on selfillummapenable:on opacitymapenable:on
		spcl2.mat = mat3
		spcl2.mat.name = "CloudLowBriM"
		
	--Create CloudLowDark
		
		c_nois01 = noise phase:(cld3_pha.value+0.2) Noise_Size:(siz_cld3.value*500) noiseType:2 Color_1:(cld3_col.color-[20,20,20]) Color_2:(cld3_col.color-[85,85,85]) Levels:3.0 Low_Threshold:0.1 High_Threshold:0.9
		c_nois02 = noise phase:(cld3_pha.value+0.2) Noise_Size:(siz_cld3.value*1250) noiseType:2 Color_1:(Color 170 170 170) Color_2:(Color 250 250 250) Levels:3.0 Low_Threshold:0.1 High_Threshold:0.9
		c_nois03 = noise phase:(cld3_pha.value+4) Noise_Size:(siz_cld3.value*200) noiseType:1 Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:4.0 Low_Threshold:0.0 High_Threshold:0.61
		c_nois04 = noise phase:(cld3_pha.value) Noise_Size:(siz_cld3.value*3500) noiseType:1 map2:c_nois03 map1Enabled:off map2Enabled:on Color_1:(Color 0 0 0) Color_2:(Color 255 255 255) Levels:3.0 Low_Threshold:(cld3_val.value+0.54) High_Threshold:(cld3_val.value+0.7)

		mat4 = standardmaterial filter:(Color 100 100 100) diffusemap:c_nois01 opacitymap:c_nois04 shininess:0 shinestrength:0 selfillum:60 opacity:0 diffusemapenable:on opacitymapenable:on		
		spcl22.mat = mat4
		spcl22.mat.name = "CloudLowDarkM"
		)
		Rdraw3()
		)
	
	on delete_sky pressed do
		(
		delete $SkyBase*
		delete $CloudHight*
		delete $CloudMid*
		delete $CloudLowBri*
		delete $CloudLowDark*
		)
		
	on siz_sky0 changed value do
		(
		spsk.scale = [siz_sky0.value,siz_sky0.value,siz_sky0.value]
		select spsk
		spcl0.scale = [siz_sky0.value,siz_sky0.value,siz_sky0.value]
		select spcl0
		spcl1.scale = [siz_sky0.value,siz_sky0.value,siz_sky0.value]
		select spcl1
		spcl2.scale = [siz_sky0.value,siz_sky0.value,siz_sky0.value]
		select spcl2
		spcl22.scale = [siz_sky0.value,siz_sky0.value,siz_sky0.value]
		select spcl22
		)
		
	on hem_sky0 changed value do
		(
		spsk.hemisphere = hem_sky0.value
		select spsk
		spcl0.hemisphere = hem_sky0.value
		select spcl0
		spcl1.hemisphere = hem_sky0.value
		select spcl1
		spcl2.hemisphere = hem_sky0.value
		select spcl2
		spcl22.hemisphere = (hem_sky0.value+0.003)
		spcl22.radius = (1300000*(hem_sky0.value-0.09))
		select spcl22
		)
		
	on siz_cld1 changed value do
		(
		siz_cld1.value = siz_cld1.value
		Rdraw1()
		)
		
	on siz_cld2 changed value do
		(
		siz_cld2.value = siz_cld2.value
		Rdraw2()
		)
		
	on siz_cld3 changed value do
		(
		siz_cld3.value = siz_cld3.value
		Rdraw3()
		)
		
	on sky1_col changed value do
		(
		sky1_col.color = sky1_col.color
		Rdraw0()	
		)
		
	on sky2_col changed value do
		(
		sky2_col.color = sky2_col.color
		Rdraw0()	
		)
		
	on sky3_col changed value do
		(
		sky3_col.color = sky3_col.color
		Rdraw0()
		)
		
	on cld1_col changed value do
		(
		cld1_col.color = cld1_col.color
		Rdraw1()
		)
		
	on cld2_col changed value do
		(
		cld2_col.color = cld2_col.color
		Rdraw2()		
		)
	on cld3_col changed value do
		(
		cld3_col.color = cld3_col.color
		Rdraw3()		
		)
		
	on cld1_pha changed value do
		(
		cld1_pha.value = cld1_pha.value
		Rdraw1()
		)
		
	on cld2_pha changed value do
		(
		cld2_pha.value = cld2_pha.value
		Rdraw2()
		)
		
	on cld3_pha changed value do
		(
		cld3_pha.value = cld3_pha.value
		Rdraw3()
		)
		
	on cld1_val changed value do
		(
		cld1_val.value = cld1_val.value
		Rdraw1()
		)
		
	on cld2_val changed value do
		(
		cld2_val.value = cld2_val.value
		Rdraw2()
		)
		
	on cld3_val changed value do
		(
		cld3_val.value = cld3_val.value
		Rdraw3()
		)
)
